﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.display.DisplayObject;
	import flash.events.KeyboardEvent;
	import flash.ui.Keyboard;
	import flash.events.MouseEvent;
	import flash.geom.*;
	import flash.display.*;
	
	public class Boussoler extends Sprite
	{
		private var col:uint = 20;
		private var line:uint = 20;
		private var clip:Sprite;
		private var angle:Number;
		private var fillType:String = GradientType.LINEAR;
		private var spreadMethod:String = SpreadMethod.REPEAT;
		private var colors:Array = [0xFFFF00,0xFF6600,0xFF0000];
		private var colorz:Array = [0x000000,0xFFFFFF,0xFF0000]
		private var alphas:Array = [1,1,1];
		private var ratios:Array = [0,200, 255];
		private var matr:Matrix = new Matrix();
		
				
		public function Boussoler()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
			
		}
		private function fullhandler(e:FullScreenEvent):void
		{
			while(numChildren>0){
				var c:DisplayObject = getChildAt(0);
				removeChildAt(0);
				c = null;
			}
			init();
		}
		
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			init();
		}
		private function init():void
		{
			var nbrl:Number = stage.stageWidth/col;
			var nbrh:Number = stage.stageHeight/line;
			var rotator:int = Math.random()*30;
			
			
			
			for(var i:uint=1;i<line;i++){
				for(var j:uint=1;j<col;j++){
					clip = new Sprite();
					//clip.graphics.lineStyle(1,0xffffff,.2);
					//clip.graphics.beginFill(0x00E0E7,.65);
					matr.createGradientBox(50,50,0,0,0);
					clip.graphics.beginGradientFill(fillType,colorz,alphas,ratios,matr,spreadMethod);
					//clip.graphics.drawRoundRect(0,0,50,100,20,20);
					clip.graphics.drawCircle(0,0,40);
					clip.graphics.moveTo(0,rotator);
					clip.graphics.lineTo(0,5);
					clip.graphics.endFill();
					clip.x = j*nbrl;
					clip.y = i*nbrh;
					addChild(clip);
					clip.addEventListener(Event.ENTER_FRAME,enterHandler);
					clip.addEventListener(MouseEvent.MOUSE_OVER, navigator);
					//clip.addEventListener(KeyboardEvent.KEY_DOWN, navigator);
					
					
				}
				
			}
			
		}
		
		private function enterHandler(e:Event):void
		{
			angle = Math.atan((e.currentTarget.y-mouseY)/(e.currentTarget.x-mouseX));
			e.currentTarget.rotation = angle*180/Math.PI+Math.cos(angle)*200;
			e.currentTarget.scaleY = angle;
		}
		
		private function navigator(event:MouseEvent):void{
			
			/*var key:uint = event.keyCode;
				switch (key) {
					case Keyboard.LEFT:
					clip.rotationY -= 5;
					break;
					
					case Keyboard.UP:
					clip.rotationX -= 5;
					break;
					
					case Keyboard.DOWN:
					clip.rotationX += 5;
					break;
					
					case Keyboard.RIGHT:
					clip.rotationX += 5;
					break;
					
				}
				
				trace("yes");*/
			
			
			if(mouseX <= 100 && mouseY >= 250 && mouseY <= 350){
				trace("YES_left");
				rotationY -= 5;
			}
			if(mouseX >= 250 && mouseX <= 350 && mouseY <= 100){
				trace("YES_up");
				rotationX -= 5;
			}
			if(mouseX >=500 && mouseY >= 250 && mouseY <= 350){
				trace("YES_right");
				rotationX += 5;
			}
			if(mouseX >=250 && mouseX <= 350 && mouseY >= 500){
				trace("YES_down");
				rotation += 5;
			}
			
		}
	}
}